<!DOCTYPE html>
<html>
  <head lang="en">
    <meta charset="utf-8" />
    <meta content="width=device-width" name="viewport" />
    <title>Embedding VfB example</title>
    <script type="text/javascript" src="creds-sample.js"></script>
    <script type="text/javascript" src="nums-sample.js"></script>
    <style>
      body {
        align-items: start;
        column-gap: 32px;
        display: grid;
        grid-template-columns: repeat(2, auto);
      }
      body,
      button,
      input,
      select {
        font-family: monospace !important;
      }
      button,
      select {
        height: 32px;
      }
      button[type="submit"] {
        margin-bottom: 2px;
        margin-top: 2px;
      }
      form {
        display: grid;
      }
      iframe {
        border: none;
        box-shadow: rgb(0 0 0 / 25%) 0px 14px 28px,
          rgb(0 0 0 / 22%) 0px 10px 10px;
      }
      input[type="radio"] {
        height: 16px;
        margin: 0;
      }
      input[type="email"],
      input[type="password"],
      input[type="text"],
      input[type="number"] {
        height: 26px;
      }
      label {
        display: grid;
        margin-bottom: 6px;
        row-gap: 4px;
      }
      .two_columns {
        column-gap: 4px;
        display: grid;
        grid-template-columns: repeat(2, auto);
        row-gap: 4px;
      }
      .inline_form {
        align-items: end;
        column-gap: 4px;
        display: grid;
        grid-template-columns: repeat(2, 1fr);
      }
      .inline_form > label {
        margin-bottom: 0;
      }
      .inline_form > button {
        margin: 0;
      }
      .divider {
        height: 16px;
      }
      .header {
        display: grid;
        row-gap: 8px;
      }
      .radio_input {
        align-items: center;
        display: grid;
        grid-template-columns: 32px auto;
      }
      .subtitle {
        margin-bottom: 8px;
        text-decoration: underline;
      }
      .title {
        font-size: 1.28em;
      }
      #content {
        justify-self: start;
        margin-bottom: 32px;
      }
      #controls {
        row-gap: 8px;
        width: 360px;
      }
      #index {
        justify-self: end;
        position: sticky;
        top: 8px;
      }
      #login {
        display: grid;
        row-gap: 8px;
        width: 360px;
      }
    </style>
  </head>
  <body>
    <iframe id="index" src="phone.html" width="360" height="552"></iframe>

    <div id="content">
      <div id="login">
        <div class="header">
          <div class="title">Please, sign in</div>
          <div class="subtitle">Open devtools to see console!</div>
          <form id="discovery_form">
            <label for="discovery_input"
              >Discovery
              <input
                type="text"
                id="discovery_input"
                placeholder="Discovery"
                value="https://discover.enreachvoice.com/api/user/"
                required
            /></label>
            <button type="submit">setDiscoveryUrl()</button>
            <script>
              document
                .getElementById("discovery_form")
                .addEventListener("submit", (e) => {
                  e.preventDefault();
                  sendMessage({
                    discoveryUrl:
                      document.getElementById("discovery_input").value,
                  });
                });
            </script>
          </form>
        </div>

        <div class="divider"></div>

        <form id="username_login_form">
          <label for="username_input"
            >Username
            <input
              type="email"
              id="username_input"
              placeholder="Username"
              required
          /></label>
          <label for="password_input"
            >Password
            <input
              type="password"
              id="password_input"
              placeholder="Password"
              required
          /></label>
          <label for="user_silo_input"
            >Silo name (optional)
            <input type="text" id="user_silo_input" placeholder="Silo name"
          /></label>
          <button type="submit">loginUsingUsernameAndPassword()</button>
          <script>
            document
              .getElementById("username_login_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  action: "login_username_password",
                  username: document.getElementById("username_input").value,
                  password: document.getElementById("password_input").value,
                  siloName: document.getElementById("user_silo_input").value,
                });
              });
          </script>
        </form>

        <div class="divider"></div>

        <form id="sso_login_form">
          <label for="sso_username_input"
            >Username
            <input
              type="email"
              id="sso_username_input"
              placeholder="Username"
              required
          /></label>
          <label for="sso_silo_input"
            >Silo name (optional)
            <input type="text" id="sso_silo_input" placeholder="Silo name"
          /></label>
          <button type="submit">loginUsingSSO()</button>
          <script>
            document
              .getElementById("sso_login_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  action: "login_sso",
                  username: document.getElementById("sso_username_input").value,
                  siloName: document.getElementById("sso_silo_input").value,
                });
              });
          </script>
        </form>

        <div class="divider"></div>

        <form id="header_login_form">
          <label for="auth_header_input"
            >AuthHeader
            <input
              type="text"
              id="auth_header_input"
              placeholder="AuthHeader"
              required
          /></label>
          <label for="expires_in_input"
            >Expires in
            <input
              type="text"
              id="expires_in_input"
              placeholder="Expires in"
              required
          /></label>
          <label for="user_id_input"
            >User id
            <input
              type="text"
              id="user_id_input"
              placeholder="User Id"
              required
          /></label>
          <label for="header_username_input"
            >Username
            <input
              type="text"
              id="header_username_input"
              placeholder="Username"
              required
          /></label>
          <label for="header_silo_input"
            >Silo name (optional)
            <input type="text" id="header_silo_input" placeholder="Silo name"
          /></label>
          <button type="submit">loginUsingAuthHeader()</button>
          <script>
            document
              .getElementById("header_login_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  action: "login_authheader",
                  authHeader:
                    document.getElementById("auth_header_input").value,
                  expiresIn: document.getElementById("expires_in_input").value,
                  userId: document.getElementById("user_id_input").value,
                  username: document.getElementById("header_username_input")
                    .value,
                  siloName: document.getElementById("header_silo_input").value,
                });
              });
          </script>
        </form>
      </div>

      <div id="controls" style="display: none">
        <div class="header">
          <div id="username" class="title"></div>
          <button onclick="sendMessage({ getUserStatus: true })">
            getUserStatus()
          </button>
          <button onclick="sendMessage({ logout: true })">logout()</button>
        </div>

        <div class="divider"></div>
        <div class="title">Phone settings</div>

        <form id="lang_form" class="inline_form">
          <label for="lang_selection"
            >Language
            <select id="lang_selection" required>
              <option value="en">English</option>
              <option value="fi">Suomi</option>
              <option value="sv">Svenska</option>
            </select></label
          >
          <button type="submit">setPhoneLanguage()</button>
          <script>
            document
              .getElementById("lang_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  lang: document.getElementById("lang_selection").value,
                });
              });
          </script>
        </form>

        <form id="audio-handling_form" class="inline_form">
          <label for="audio-handling_selection"
            >Audio handling
            <select id="audio-handling_selection" required>
              <option value="default">Default</option>
              <option value="legacy">Legacy</option>
            </select></label
          >
          <button type="submit">setAudioHandling()</button>
          <script>
            document
              .getElementById("audio-handling_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  audioHandling: document.getElementById(
                    "audio-handling_selection"
                  ).value,
                });
              });
          </script>
        </form>

        <form id="alerts_form" class="inline_form">
          <label for="alerts_selection"
            >Alerts
            <select id="alerts_selection" required>
              <option value="true">ON</option>
              <option value="false">OFF</option>
            </select></label
          >
          <button type="submit">setPhoneAlerts()</button>
          <script>
            document
              .getElementById("alerts_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  alertsEnabled:
                    document.getElementById("alerts_selection").value,
                });
              });
          </script>
        </form>

        <div class="divider"></div>
        <div class="title">Direct call initialization</div>

        <form id="call_form">
          <label for="call_number_selection"
            >Preset number
            <div class="radio_input">
              <input
                id="preset_number_radio"
                type="radio"
                name="call_number"
                checked
              />
              <select id="call_number_selection"></select></div
          ></label>
          <label for="call_number_input"
            >Custom number
            <div class="radio_input">
              <input id="custom_number_radio" type="radio" name="call_number" />
              <input
                type="text"
                id="call_number_input"
                placeholder="Phone number"
              /></div
          ></label>
          <button type="submit">call()</button>
          <script>
            const callSelection = document.getElementById(
              "call_number_selection"
            );
            for (let key in numbers) {
              let element = document.createElement("option");
              element.value = key;
              element.text = `${numbers[key].info} <${numbers[key].number}>`;
              callSelection.append(element);
            }
            document
              .getElementById("call_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                const targetNumber = document.getElementById(
                  "preset_number_radio"
                ).checked
                  ? numbers[
                      document.getElementById("call_number_selection").value
                    ].number
                  : document.getElementById("call_number_input").value;
                sendMessage({
                  targetNumber,
                });
              });
          </script>
        </form>

        <div class="two_columns">
          <button onclick="callAction('answer')">answerCall()</button>
          <button onclick="callAction('reject')">rejectCall()</button>
        </div>

        <div class="inline-text">
          callId:&nbsp;
          <span id="call_id">not set...</span>
        </div>
        <div class="inline-text">
          consultedCallId:&nbsp;
          <span id="consulted_call_id">not set...</span>
        </div>

        <div class="divider"></div>
        <div class="title">Call actions</div>

        <div class="two_columns">
          <div class="subtitle">Regular</div>
          <div class="subtitle">Consultation</div>
          <button onclick="callAction('end')">endCall()</button>
          <button onclick="callAction('end', 'consulted_call_id')">
            endCall()
          </button>
          <div class="divider"></div>
          <div class="divider"></div>
          <button onclick="callAction('mute')">muteCall()</button>
          <button onclick="callAction('mute', 'consulted_call_id')">
            muteCall()
          </button>
          <button onclick="callAction('unmute')">unmuteCall()</button>
          <button onclick="callAction('unmute', 'consulted_call_id')">
            unmuteCall()
          </button>
          <button onclick="callAction('pause')">pauseCall()</button>
          <button onclick="callAction('pause', 'consulted_call_id')">
            pauseCall()
          </button>
          <button onclick="callAction('resume')">resumeCall()</button>
          <button onclick="callAction('resume', 'consulted_call_id')">
            resumeCall()
          </button>
          <div class="divider"></div>
          <div class="divider"></div>
          <button onclick="callAction('start')">startCallRecording()</button>
          <button onclick="callAction('start', 'consulted_call_id')">
            startCallRecording()
          </button>
          <button onclick="callAction('stop')">stopCallRecording()</button>
          <button onclick="callAction('stop', 'consulted_call_id')">
            stopCallRecording()
          </button>
          <script>
            function callAction(callAction, elementId = "call_id") {
              sendMessage({
                callAction,
                targetId: document.getElementById(elementId).innerHTML,
              });
            }
          </script>
        </div>

        <div class="divider"></div>
        <div class="title">Call transfer</div>

        <form id="user_data_form">
          <label for="user_data_input"
            >User data (in JSON format)
            <input
              type="text"
              id="user_data_input"
              placeholder='{"foo": "bar"}'
              required
            />
          </label>
          <button type="submit">setUserData()</button>
          <script>
            document
              .getElementById("user_data_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  data: document.getElementById("user_data_input").value,
                });
              });
          </script>
        </form>

        <form id="transfer_form">
          <label for="transfer_number_selection"
            >Preset number
            <div class="radio_input">
              <input
                id="transfer_preset_radio"
                type="radio"
                name="transfer_number"
                checked
              />
              <select id="transfer_number_selection"></select></div
          ></label>
          <label for="transfer_number_input"
            >Custom number
            <div class="radio_input">
              <input
                id="transfer_custom_radio"
                type="radio"
                name="transfer_number"
              />
              <input
                type="text"
                id="transfer_number_input"
                placeholder="Phone number"
              /></div
          ></label>
          <button type="submit" name="direct">transferCall('direct')</button>
          <div class="two_columns">
            <button type="submit" name="consulted">
              transferCall('consulted')
            </button>
            <button type="submit" name="confirm">confirmTransfer()</button>
          </div>
          <script>
            const transferSelection = document.getElementById(
              "transfer_number_selection"
            );
            for (let key in numbers) {
              let element = document.createElement("option");
              element.value = key;
              element.text = `${numbers[key].info} <${numbers[key].number}>`;
              transferSelection.append(element);
            }
            document
              .getElementById("transfer_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                const transferToNumber = document.getElementById(
                  "transfer_preset_radio"
                ).checked
                  ? numbers[
                      document.getElementById("transfer_number_selection").value
                    ].number
                  : document.getElementById("transfer_number_input").value;
                switch (e.submitter.name) {
                  case "confirm":
                    sendMessage({
                      confirmTransfer: true,
                    });
                    break;
                  case "consulted":
                    sendMessage({
                      transferType: "consulted",
                      transferToNumber,
                    });
                    break;
                  case "direct":
                    sendMessage({
                      transferType: "direct",
                      transferToNumber,
                    });
                    break;
                }
              });
          </script>
        </form>

        <div class="divider"></div>
        <div class="title">Service call initialization</div>

        <form id="service_call_callback_form">
          <label for="callback_number_input"
            >Target number
            <input
              id="callback_number_input"
              type="text"
              placeholder="Target number"
            />
          </label>
          <label for="callback_list_id_input"
            >Callback list ID
            <input
              id="callback_list_id_input"
              type="text"
              placeholder="Callback list ID"
            />
          </label>
          <label for="callback_request_id_input"
            >Callback request ID
            <input
              id="callback_request_id_input"
              type="text"
              placeholder="Callback request ID"
            />
          </label>
          <label for="callback_cli_input"
            >CLI
            <input id="callback_cli_input" type="text" placeholder="CLI" />
          </label>
          <button type="submit">callOutboundCallback()</button>
          <script>
            document
              .getElementById("service_call_callback_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  targetNumber: document.getElementById("callback_number_input")
                    .value,
                  callbackListId: document.getElementById(
                    "callback_list_id_input"
                  ).value,
                  callbackRequestId: document.getElementById(
                    "callback_request_id_input"
                  ).value,
                  cli: document.getElementById("callback_cli_input").value,
                });
              });
          </script>
        </form>

        <form id="service_call_queue_form">
          <label for="queue_number_input"
            >Target number
            <input
              id="queue_number_input"
              type="text"
              placeholder="Target number"
            />
          </label>
          <label for="queue_id_input"
            >Queue ID
            <input id="queue_id_input" type="text" placeholder="Queue ID" />
          </label>
          <label for="queue_cli_input"
            >CLI
            <input id="queue_cli_input" type="text" placeholder="CLI" />
          </label>
          <button type="submit">callOutboundQueue()</button>
          <script>
            document
              .getElementById("service_call_queue_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  targetNumber:
                    document.getElementById("queue_number_input").value,
                  queueId: document.getElementById("queue_id_input").value,
                  cli: document.getElementById("queue_cli_input").value,
                });
              });
          </script>
        </form>

        <div class="divider"></div>
        <div class="title">Supervision</div>

        <form id="supervision_form">
          <label for="supervision_target_user_id">
            Target user ID
            <input
              id="supervision_target_user_id"
              type="text"
              placeholder="Target user ID"
            />
          </label>
          <button type="submit" name="supervision_submit">startCallSupervision()</button>
          <script>
            document
              .getElementById("supervision_form")
              .addEventListener("submit", (e) => {
                e.preventDefault();
                sendMessage({
                  action: "start_call_supervision",
                  targetUserId:
                    document.getElementById("supervision_target_user_id").value,
                });
              });
          </script>
        </form>

        <div class="divider"></div>
        <div class="title">API operations</div>

        <form id="api_form">
          <label for="allocation_timeout_input"
            >Fetch allocation
            <input
              name="allocation_timeout_input"
              type="number"
              min="0"
              max="30"
              placeholder="Timeout"
              value="1"
            />
          </label>
          <button type="submit" name="allocation_timeout_submit">
            Fetch allocation
          </button>
        </form>
        <script>
          document
            .getElementById("api_form")
            .addEventListener("submit", (e) => {
              e.preventDefault();
              switch (e.submitter.name) {
                case "allocation_timeout_submit":
                  sendMessage({
                    allocationTimeout: document.getElementsByName(
                      "allocation_timeout_input"
                    )[0].value,
                  });
                  break;
              }
            });
        </script>
      </div>
    </div>
    <script>
      function sendMessage(message) {
        document
          .getElementById("index")
          .contentWindow.postMessage(JSON.stringify(message), "*");
      }
    </script>
  </body>
</html>
